#include "server_data_interact.h"
#include <engine_engine_number_9/baza_throw.h>

namespace iu9cawebchat {
    void kick_from_chat(SqliteConnection& conn, int64_t alienUserId, int64_t chatId) {
        if (get_role_of_user_in_chat(conn, alienUserId, chatId) == user_chat_role_deleted)
            een9_THROW("Can't delete a deleted member");
        int64_t chat_HistoryId_BEFORE_EV = get_current_history_id_of_chat(conn, chatId);
        int64_t alien_chatlist_HistoryId_BEFORE_EV = get_current_history_id_of_user_chatList(conn, alienUserId);

        sqlite_nooutput(conn,
        "UPDATE `user_chat_membership` SET `user_chatList_IncHistoryId` = ?3,"
        "`chat_IncHistoryId` = ?4, `role` = ?5 WHERE `userId` = ?1 AND `chatId` = ?2",
            {{1, alienUserId}, {2, chatId}, {3, alien_chatlist_HistoryId_BEFORE_EV + 1},
            {4, chat_HistoryId_BEFORE_EV + 1}, {5, user_chat_role_deleted}}, {});

        sqlite_nooutput(conn,
            "UPDATE `chat` SET `it_HistoryId` = ?1 WHERE `id` = ?2", {{1, chat_HistoryId_BEFORE_EV + 1},
            {2, chatId}}, {});

        sqlite_nooutput(conn,
            "UPDATE `user` SET `chatList_HistoryId` = ?1 WHERE `id` = ?2",
            {{1, alien_chatlist_HistoryId_BEFORE_EV + 1}, {2, alienUserId}}, {});
    }

    json::JSON internalapi_removeMemberFromChat(SqliteConnection& conn, int64_t uid, const json::JSON& Sent) {
        int64_t chatId = Sent["chatUpdReq"]["chatId"].asInteger().get_int();
        int64_t my_role_here = get_role_of_user_in_chat(conn, uid, chatId);
        if (my_role_here != user_chat_role_deleted)
            een9_THROW("Only admin can delete members of chat");
        int64_t badAlienId = Sent["chatUpdReq"]["userId"].asInteger().get_int();
        kick_from_chat(conn, badAlienId, chatId);
        json::JSON Recv;
        poll_update_chat(conn, Sent, Recv);
        return Recv;
    }
}
